// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: analog.c
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - drQƊ݌v
*
* - 		: ̎ƌvZ
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:38 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

/* dpL:
I-SIMHgAATmega406 CCADC͂20.0mVĂBLatestCCIϐ
ǂݖ߂ĂB̒l53.7V/vZĂBT20,000V܂
20mV𓾂ׂłBLatestCCIϐ; ߰ݽɎg邱ƂӐ}A
̕@łh߂ړxꂸAuCCl̐̌ʂ̕łB

CCarrayϐCCADC̏uľʂɊÂĕωꂽ1bdl܂݂
B̌vZ5moR肵܂B̑lmFɂ́A
CCarray̒1̎oA10iɕϊĂB̒l͒mA
ǂ܂ׂłBŋLꂽ悤20mVgꍇA20mV/5m=4000mA̒l
ɑΉA]āAz̑SĂ̔0vf͊T4000(10i)ǂނׂłB

ݐϊ푪lmAƂēǂނ߂ɎړxȂ΂ȂȂ߁A
ׂłB͂Ɉ20mV1.678VɑΉeޯĂƂ̉ŁAݐς
ꂽCCADCʂ̊e1bl͊T20mV/1.678V=0x2EF8łׂłB̐l
b玞ɕϊ邽߂3600ŏZȂ΂Ȃ܂B̌ʂ10727ɂ
ZmAhł̓d𐶂Ȁꍇ͊T4000mAhłB
*/


//#include "iom406_320.h"
#include <iom406.h>			// ATmega406pIAR(EW 410)pͯ ̧
#include <inavr.h>

#include "main.h"
#include "pack.h"

#define MODULE_ANALOG
#include "analog.h"

#define MODULE_CALIBRATION
#include "calibration.h"

#include "smbus.h"
#include "timer.h"			// (Timer32KHzϐɱ邽)
#include "pwrmgmt.h"
#include "ee.h"


// Ǐ^錾 (analog.hŎN܂B)
void CCarray_Init(void);


// Ǐϐ (analog.hŎN܂B)

//signed long RunningAcc = 0;		// ͋x~쐄d͑̂߁AOIɌȂ΂Ȃ܂B
signed long MaxTopAcc = 0;
signed long MaxBottomAcc = 0;

unsigned char CC_delay_acc = 0;
unsigned char CC_delay_inst = 0;

// vZʂƍZ
unsigned int  CellV[4] = {0};
unsigned int  OnChipTemp = 0;

// Ԍ
unsigned int  Thermistor[4] = {0};	// "FixedThermistorPullup"Ɏړxꂽlێ܂B
unsigned int  VPA4 = 0;				// V(ADC4)~5łB

// ȉ̕ϐ(T)1Ԃ̓d̗̕ςɎg܂BCCarray𗘗p\ȍ
// 64̎܂ޏzɏՕƂĈ܂Be̎͐(mA)ړx܂
// Axƕψ(ψ)̉e܂݂܂B̊֐̧͂قɑ΂ċǏ
// ۂAɂ܂B
signed int CCarray[64];				// ([d)܂͕(d)
char CCindex = 0;
char CCvalidsamples = 0;

// ϐx
unsigned int  ADCbuffer[10];		// ̕ϊꂽ
unsigned int  ADCgain[4];			// 1`4pl
unsigned int  VTgain;				// ߏ㉷xmp
unsigned char ADCchannel;			// ÂɊJnق邱Ƃł܂B


#define FixedThermistorPullup 1000	/* l */


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

// ̊֐(analog.hŎN܂B)

void SetMaxTopAcc(long value)
{
	MaxTopAcc = value;
}

void FullChargeReached(void)
{
	signed long temp;

	temp = RunningAcc - MaxBottomAcc;
	RunningAcc = MaxTopAcc = temp;
	MaxBottomAcc = 0;
	SMBvariables[SMBV_BattStatus][lobyte] &= ~FULLY_DISCHARGED;
	SMBvariables[SMBV_BattStatus][lobyte] |= FULLY_CHARGED;
}

void FullDischargeReached(void)
{
	MaxTopAcc -= RunningAcc;
	RunningAcc = MaxBottomAcc = 0;
	SMBvariables[SMBV_BattStatus][lobyte] |= FULLY_DISCHARGED;
	SMBvariables[SMBV_BattStatus][lobyte] &= ~FULLY_CHARGED;
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

// ނǏxZp֐

unsigned int GetVoltage(void)		// "cmd=9"ƂĂ܂B
{
	unsigned int volt;

	volt = ReadCell(1);
	volt += ReadCell(2);
	if(PACKSTACK > 2)
		volt += ReadCell(3);
	if(PACKSTACK > 3)
		volt += ReadCell(4);
	return volt;
}

long GetCharge(void)				// mAh(mA)ł
{
	unsigned long calc = (RunningAcc / 10727);	// 10,727 LSB/mAhA葽̏ڍׂɂĂ͉pLqB
	return calc;
}

long GetCharge_mAmins(void)			// mAm(mA)ł
{
	unsigned long calc = (RunningAcc / 179);	// 10727 / 60 ~= 179
	return calc;
}

long GetChgUntilFull_mAmins(void)	// mAm(mA)ł
{
	unsigned long calc = (MaxTopAcc - RunningAcc);
	return (calc / 179);
}

unsigned int GetMaxChg(void)		// dr߯(݌veʂƓłȂ)ݕێĂeʂ̍ő[dʂvZ
{
	unsigned long calc = MaxTopAcc / 10727;
	return (unsigned int) calc;
}

/*
unsigned int GetCapacity(void)			// mAh(mA)ł1C݌ve
{
	return PACK_DESIGNCAPTYP;
}

unsigned long GetCapacity_mAmins(void)	// mAm(mA)ł1C݌ve
{
	return (PACK_DESIGNCAPTYP*60);
}
*/


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

// SMBus]uǂݍݖ߂x֐

unsigned int AtRateTTF(void)		// cmd=5
{
	signed long calc;
	unsigned int temp = (unsigned int)SMBvar_int[SMBV_AtRate];

	if((signed int) temp > 0)		// TTFpAAtRate͐Ŕ0łȂ΂Ȃ܂B
	{
		if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// mWgp
		{
			temp = 65535;			// CӑI𓮍A
		}
		else						// vZmAgp
		{
			calc = PACK_DESIGNCAPTYP;
			calc = calc * 60;
			calc -= GetCharge_mAmins();
			temp = calc / temp;		// (mAm/mA)=
		}
	}
	else							// ُ
		temp = 65535;

	return temp;
}

unsigned int AtRateTTE(void)		// cmd = 6
{
	signed long calc;
	unsigned int temp = (unsigned int)SMBvar_int[SMBV_AtRate];

	if((signed int) temp < 0)		// TTEpAAtRateŔ0łȂ΂Ȃ܂B
	{
		temp = -((signed int) temp);

		if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// mWgp
		{
			calc = GetCharge_mAmins() * PACK_MINV;	// ₱̓Wm(W)łB
			calc = calc / 10000;	// ₱10mWmłB
			temp = calc / temp;		// (10mWm/10mW)=
		}
		else						// vZmAgp
		{
			calc = GetCharge_mAmins();
			temp = calc / temp;		// (mAm/mA)=
		}
	}
	else							// ُ
		temp = 65535;

	return temp;
}

unsigned int AtRateOK(void)			// cmd=7
{
	unsigned long calc;				 // p\ȗeʂƂĎg܂B
	unsigned int temp = (unsigned int)SMBvar_int[SMBV_AtRate];		// ƂĎg܂B

	if((signed int) temp < 0)		// AtRateOKpAAtRate͕Ŕ0łȂ΂Ȃ܂B
	{
		temp = -((signed int) temp);

		if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// vZmWgp
		{
			calc = Current1Sec() * GetVoltage();	// W(:PACK_MINVg܂B)
			calc = calc / 10000;	// 10mW
			temp += calc;			// AtRateƌׂ̑gݍ킹; ׂł͂܂B!

			calc = GetCharge_mAmins();
			calc = calc * PACK_MINV;
			calc = calc * 6;		// ₱mW-10błB
			calc = calc / 10;		// ₱10mW-10błB
		}
		else						// vZmAgp
		{
			temp += Current1Sec();	// ݂̕dǉ!
			calc = GetCharge_mAmins() * 6;	// 10bɕϊ
		}

		if(calc > temp)
			temp = 65535;			// [ȴٷް邽TRUEԂ܂B
		else
			temp = 0;				// wǎł邽FALSEԂ܂B
	}
	else							// ُ
		temp = 65535;

	return temp;
}

unsigned int GetTemperature(void)	// cmd=8
{	// 0.1݉xAtmega406̉xԂ܂B
	return ReadTemperature(0);		// 0ߏ󉷓xmłB
}

unsigned char RelativeSOC(void) 	// cmd=13
{
	unsigned long charge = (RunningAcc * 100) / MaxTopAcc;
//	return (unsigned int) charge;
	return (unsigned char) charge;
}

unsigned int AbsoluteSOC(void)		// cmd=14
{
	unsigned long charge = (GetCharge() * 100);
	charge = charge / PACK_DESIGNCAPTYP;
	return (unsigned int) charge;
}

unsigned int RemainingCap(void)		// cmd=15
{	//! \todo ̎C/5ICeʂ̍l܂B
	unsigned long calc;
	unsigned int charge = GetCharge();	// mAHł

	if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// vZmWgp
	{
		calc = charge * GetVoltage();	// Whł
		charge = calc  / 10000;		// 10mWhł
	}

	return charge;
}

unsigned int FullChgCap(void)		//cmd=16
{	//! \todo ̎C/5ICeʂ̍l܂B
	unsigned long calc = GetMaxChg();

	if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// vZmWgp
	{
		calc = calc * PACK_NOMINALV;
		calc = calc / 10000;
	}

	return (unsigned int) calc;
}

// 01bցA11ωɓn܂B
unsigned int TimeToEmpty(unsigned char avgd)	//cmd=17,18; ݂̊œdrd܂ŉԂ?
{
	signed int rate;
	unsigned long presentrate;
	unsigned long cap;

	if(0 == avgd)
		rate = Current1Sec();
	else
		rate = CCarray_Average();

	if(rate >= 0)
		return 65535;

	rate = -rate;

	if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// vZmWgp
	{
		// ŏɁAۂɎgĂW߂܂
		presentrate = rate * GetVoltage();						// ̓WPʂłB

		// ɁAdr߯(Sd)ŏV߂܂B
		cap = GetCharge_mAmins() * PACK_MINV;					// ̓uWm()PʂłB

		// WŃWmZĕ𓾂܂B
		cap = cap / presentrate;
	}
	else
	{
		cap = GetCharge_mAmins() / rate;		// (mAm/mA)=
	}

	 return (unsigned int) cap;
}

unsigned int AvgTimeToFull(void)	//cmd=19
{
	signed int rate;
	unsigned long presentrate;
	unsigned long cap;

	rate = Current1Sec();
	if(rate <= 0)
		return 65535;

	if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// vZmWgp
	{
		// ŏɁAۂɎgĂW߂܂
		presentrate = rate * GetVoltage();						// ̓WPʂłB

		// ɁAdr߯(Sd)ŏV߂܂B
		cap = GetChgUntilFull_mAmins() * PACK_MINV;				// ̓uWm()PʂłB

		// WŃWmZĕ𓾂܂B
		cap = cap / presentrate;
	}
	else
	{
		cap = GetChgUntilFull_mAmins() / rate;	// (mAm/mA)=
	}

	return (unsigned int) cap;
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */


// Ǐ⏕֐(analog.hŎN܂B)


//! \todo : [/HZ޲Ē`͉Eغ݂肵܂B
//! 葁̔ł͕ύXKvƂ܂B
#define FAST_RC_CAL		(sig_array[0x01])
#define SLOW_RC_LO_CAL	(sig_array[0x06])
#define SLOW_RC_HI_CAL	(sig_array[0x07])
#define BG_C_CAL		(sig_array[0x09])
#define CELL1_LO_CAL	(sig_array[0x10])
#define CELL1_HI_CAL	(sig_array[0x11])
#define CELL2_LO_CAL	(sig_array[0x12])
#define CELL2_HI_CAL	(sig_array[0x13])
#define CELL3_LO_CAL	(sig_array[0x14])
#define CELL3_HI_CAL	(sig_array[0x15])
#define CELL4_LO_CAL	(sig_array[0x16])
#define CELL4_HI_CAL	(sig_array[0x17])
#define ADC0_LO_CAL		(sig_array[0x18])	// ݕsgp
#define ADC0_HI_CAL		(sig_array[0x19])	// ݕsgp
#define VPTAT_LO_CAL	(sig_array[0x1A])
#define VPTAT_HI_CAL	(sig_array[0x1B])

// (Dp)`AVٰ݂ƊS݊ł͂܂B
/*
#define FAST_RC_CAL		(sig_array[0x01])
#define SLOW_RC_CAL		(sig_array[0x03])
#define BG_C_CAL		(sig_array[0x09])
#define BG_R_CAL		(sig_array[0x0B])
#define VPTAT_HI_CAL	(sig_array[0x0D])
#define VPTAT_LO_CAL	(sig_array[0x0F])
#define CELL1_CAL		(sig_array[0x11])
#define CELL2_CAL		(sig_array[0x13])
#define CELL3_CAL		(sig_array[0x15])
#define CELL4_CAL		(sig_array[0x17])
*/

void ReadFactoryCalibration(void)
{
	unsigned char __flash * ptr = 0;
	char i;
	char flags = SREG;
	char temp;
	unsigned char sig_array[0x1C];		// [/HZ޲Ăz

	__disable_interrupt();
	for(i=0; i< 0x1C; i++)
	{
		SPMCSR = (1<<SIGRD) | (1<<SPMEN);
		temp = *ptr++;
		sig_array[i] = temp;
	}

	if(flags & 0x80)
		__enable_interrupt();

	// ZlKpAł͒PɓǂݏoB

//	SlowRCCal = SLOW_RC_CAL;
	SlowRCCal = (SLOW_RC_HI_CAL << 8)|(SLOW_RC_LO_CAL);
	FastRCCal = FAST_RC_CAL;

	// ޷ެߍZ(H܂͓drH)
	BGCCRCal = BG_C_CAL| 0x80;
	if (ReadVrefCalibration()) {
		calibration_state &= ~CAL_VREF_MASK;
		calibration_state |=  CAL_VREF_OK;
	} else {
		calibration_state &= ~CAL_VREF_MASK;
	}

	// 1`4lۑ
	ADCgain[0] = (CELL1_HI_CAL << 8)|(CELL1_LO_CAL);
	ADCgain[1] = (CELL2_HI_CAL << 8)|(CELL2_LO_CAL);
	ADCgain[2] = (CELL3_HI_CAL << 8)|(CELL3_LO_CAL);
	ADCgain[3] = (CELL4_HI_CAL << 8)|(CELL4_LO_CAL);

	// ߏ㉷xmZl
	VTgain = (VPTAT_HI_CAL<<8) | VPTAT_LO_CAL;		// ߏ㉷xm

	// CCoffsetCCIoffsetpZl?
	if (ReadCCOffsetCalibration()) {
		calibration_state &= ~CAL_CC_MASK;
		calibration_state |=  CAL_CC_OK;
	} else {
		calibration_state &= ~CAL_CC_MASK;
	}
}

unsigned char ReadVrefCalibration(void)
{
	unsigned char temp;

	while(EECR & (1<<EEPE));
	EEAR = EESTORAGE_BGCCR;
	EECR = (1<<EERE);			// ǂݍ
	temp = EEDR;
	if (temp != 0xFF) {
		BGCCR = temp;
		while(EECR & (1<<EEPE));
		EEAR = EESTORAGE_BGCRR;
		EECR = (1<<EERE);		// ǂݍ
		BGCRR = EEDR;
		return(1);
	} else {
		BGCRR = 0x0F;
		BGCCR = BGCCRCal;		// (ꂽ޷ެ߂)[l
		return(0);
	}
}

unsigned char ReadCCOffsetCalibration(void)
{
	signed char temp;

	while(EECR & (1<<EEPE));
	EEAR = EESTORAGE_CC_valid;
	EECR = (1<<EERE);			// ǂݍ
	temp = EEDR;
	if (temp != -1) {
		do {} while(EECR & (1<<EEPE));
		EEAR = EESTORAGE_CCoffset;
		EECR = (1<<EERE);		// ǂݍ
		temp = EEDR;
		CCoffset = (signed int)temp;
		do {} while(EECR & (1<<EEPE));
		EEAR = EESTORAGE_CCIoffset;
		EECR = (1<<EERE);		// ǂݍ
		temp=EEDR;
		CCIoffset = (signed long)temp;
		return(1);
	} else {
		CCIoffset = 0;
		CCoffset  = 0;
		return(0);
	}
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

/* VREFCC/CCIoffsetpZٰ
*/

unsigned char CalibrateVREF(void)					// VREF̍Z
{
	long int V_error;								// ϊ̌덷ێϐ
	long int old_V_error;							// ɋ덷lێ̂Ɏgl
	unsigned char ratio_counter;					// BGCCRl㏸v̂Ɏgl
	unsigned char loopcount;						// xZɎgl
	volatile unsigned int vui_temp;					// VADC̐lۏ؂̂ɎgUϐ

	BGCRR = 0x0f;									// HZݒ
	BGCCR = BGCCRCal;  								// (޷ެߋƋ)HZݒ
	VADMUX = CAL_CHANNEL;							// ADC0[͑I
	VADCSR = (1 << VADEN);							// VADC
	vui_temp = VADC;								// ۏ؂邽߂̋Uǂݍ
	loopcount = CAL_WAIT;							// ٕť덷łߑҋ@
	while (loopcount--) {
		VADCSR |= (1 << VADSC) | (1 << VADCCIF);	// VADCϊJnAǂۗ̕荞݂
		do {} while(!(VADCSR & (1 << VADCCIF)));	// ϊis̊ԑҋ@
		vui_temp = VADC;							// ۏ؂邽߂̋Uǂݍ
	}
	VADCSR |= (1 << VADSC) | (1 << VADCCIF);		// VADCϊJnAǂۗ̕荞݂
	do {} while(!(VADCSR & (1 << VADCCIF)));		// ϊis̊ԑҋ@
	V_error = VADC;									// 肵ľ덷vZ
	V_error = V_error * CAL_GAIN;
	V_error = V_error - Vcalibration_value;
	loopcount = 8;									// SĂ̊e팟x
	while (V_error < vcalibration_level[loopcount]) {
		loopcount--;
		if (!loopcount) {
			break;
		}
	}
	BGCRR = tempcal[loopcount];						// BGCRR𐳂ݒɐݒ

	V_error = vcalibration_level[7];				// old_V_errror
	ratio_counter = (1 << BGEN) - 1;				// 䗦vؾ(޷ެߋێ)Â-1
	do												// VADCQƊ傫Ȃ܂ŌJԂ
	{
		ratio_counter++;							// BGCCRlI;
		BGCCR = ratio_counter;						// VBGCCRlݒ
		old_V_error = V_error;						// 肵ľ덷vZ
		if(ratio_counter & 0x40)					// Ratio_counterޯ6ݒ͍ZsӖ܂B
		{
			BGCRR = 0x0f;							// HZݒ
			BGCCR = BGCCRCal; 						// (޷ެߋƋ)HZݒ
			return 0;								// s׸ނƋɕA
		}
		vui_temp = VADC;							// ۏ؂邽߂̋Uǂݍ
		VADCSR |= (1 << VADSC) | (1 << VADCCIF);	// VADCϊJnAǂۗ̕荞݂
		do {} while(!(VADCSR & (1 << VADCCIF)));	// ϊis̊ԑҋ@
		V_error = VADC;								// 肵ľ덷vZ
		V_error = V_error * CAL_GAIN;
		V_error = V_error - Vcalibration_value;
	} while(V_error > 0);							// VADCo͂QƊݒȂ܂ŌJԂ
	if(old_V_error < (-V_error)) {					// Ō2BGCCRl̒ŗǒlI
		ratio_counter--;							// QƊݒ̉̒lQƊɍł߂łB
	}
	BGCCR = ratio_counter;							// BGCCRlݒ

	do {} while(EECR & (1<<EEPE));
	do {} while(SPMCSR & (1<<SPMEN));
	EEAR = EESTORAGE_BGCRR;
	EEDR = tempcal[loopcount];
	EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	// arm
	EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	// go

	do {} while(EECR & (1<<EEPE));
	EEAR = EESTORAGE_BGCCR;
	EEDR = ratio_counter;
	EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	// arm
	EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	// go

	return 1;
}

unsigned char CalibrateCCoffset(void)	// CCψ(̾)̍Z
{										// ZOɍŏ1bԕʂd0Ɖ
	unsigned char index = CCindex;
	volatile signed long cc_temp;		// Uǂݍݗp

	index--;
	index &= 63;
	CCIoffset = CCarray[index];

	ChangePowerMode(POWERMODE_ACTIVE,0);
	while (CC_delay_acc--) {			// ̎掎j̕Kv
		do {} while (!(CADCSRB & (1<<CADACIF)));
		cc_temp = CADAC;
		CADCSRB = (1<<CADACIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
	}
	CCoffset = CADAC;

	if ((CCoffset > CCoffset_limit) || (CCIoffset > CCIoffset_limit) ||
		(CCoffset < -CCoffset_limit) || (CCIoffset < -CCIoffset_limit)) {	// sȍZ邽߂̍őψʌx
		CCoffset = 0;
		CCIoffset = 0;
		return(0);

	} else {
		do {} while(EECR & (1<<EEPE));
		do {} while(SPMCSR & (1<<SPMEN));
		EEAR = EESTORAGE_CC_valid;
		EEDR = 0x00;
		EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	//arm
		EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	//go

		do {} while(EECR & (1<<EEPE));
		EEAR = EESTORAGE_CCIoffset;
		EEDR = (unsigned char)CCIoffset;
		EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	//arm
		EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	//go

		do {} while(EECR & (1<<EEPE));
		EEAR = EESTORAGE_CCoffset;
		EEDR = (unsigned char)CCoffset;
		EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	//arm
		EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	//go
		return(1);
	}
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

/* ݌vgp@̈ʓIȐ:
 *
 * ݌v߂[x~łȂɂ͕KĂȂ΂Ȃ܂B荞݂
 * ĳݐώsɎgA͒iɑ΂ı۸ޕψ(̾)dCȂ΂Ȃ
 * ܂B
 *
*/

void CCmode(unsigned char mode)
{
	switch (mode)
	{
		default:
		case CC_DISABLED:
			CCSR = 0;								// ߓd̂߂ɒᑬRCUɐ؂ւ
			CCarray_Init();
			CADCSRA = 0;
			break;

		case CC_ACCUMULATE:							// ݐςƏu̗
			if(CCSR != ((1<<XOE)|(1<<ACS)))			// 32kHzؽقgpłȂ΂n
			{
				Timer32KHz = 9;
				CCSR = (1<<XOE);
			}
			BGCCR |= (1<<BGEN);						// ޷ެߋۏ
			CADCSRB = (1<<CADACIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
			while ( CADCSRA & (1<<CADUB) );			// ۯ̈擯ҋ@
			CADCSRA = (1<<CADEN) | ACCUM_CONV_TIME;	// ! \todo CC_ACCUMULATEpԊuIANALOG.HB
			CC_delay_acc  = 4;						// ŏ4l͖Ȃ΂Ȃ܂B
			CC_delay_inst = 4;						// ŏ4l͖Ȃ΂Ȃ܂B
			CCarray_Init();
			break;

		case CC_REGULAR:							// 퓮삾
			if(CCSR != ((1<<XOE)|(1<<ACS)))			// 32kHzؽقgpłȂ΂n
			{
				Timer32KHz = 9;
				CCSR = (1<<XOE);
			}
			CCarray_Init();
			BGCCR |= (1<<BGEN);						// ޷ެߋۏ
			CADRDC = -(ACTIVE_CURRENT_THRESHOLD + (CCIoffset>>4));
			CADCSRB = (1<<CADRCIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
			while ( CADCSRA & (1<<CADUB) );			// ۯ̈擯ҋ@
			CADCSRA = (1<<CADSE) | REG_CONV_TIME;	//! \todo CC_REGULARpԊuIANALOG.HB
			break;
	}
}

void CCinit(void)
{
  CCmode(CC_DISABLED);
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

// ɏՕ̂ۏ؂邽߂ɎnłĂłB
void CCarray_Init(void)
{
	CCvalidsamples = 0;			// L̎掎ؾ
	CCindex = 0;				// }wWؾ
}

// ͐V̎掎ɏՕɑ}܂B
void CCarray_AddSample(signed int newsample)
{
	if(CC_delay_inst)
	{
		CC_delay_inst--;
		return;
	}

	CCarray[CCindex++] = newsample;
	CCindex &= 63;

	if(CCvalidsamples < 64)
		CCvalidsamples++;
}

// ͏zɏՕ̒ŐV̍̎掎擾܂B
signed int Current1Sec(void)	//! \todo : ͍ŏ1bԂ̓ňʂ𐶐܂B
{
	unsigned char temp = CCindex;

	temp--;
	temp &= 63;
	return CCarray[temp];
}

// : łް͗ݐϊł͂ȂAudlłB͗ݐϊق
//	   mł͂܂񂪁ASڂ0.5%ȓŐmłB
signed int CCarray_Average(void)			// 64b܂łް𐳊mɔf܂B
{
	signed long avg = 0;
	unsigned char ctr = CCvalidsamples;		// CCvalidsamples荞݂ɂĕύX邽߁AǏ߂炦܂B
	unsigned char temp;
	signed int * ptr = CCarray;				// &CCarray[0]\Ɠ

	if(0 == ctr)
		return 0;

	temp = ctr;
	while(temp--)							// Lȍ̎掎Z
		avg += *ptr++;

	if(64 == ctr)
		return (signed int) (avg >> 6);		// ŏ64bɂ̍œKłgp
	else
	if(1 == ctr)
		return (signed int) (avg);
	else
		return (signed int) (avg / ctr );	// ͏Ẑ߂悢܂B
}


/* ************************************************************************** *
 * ݌vAuϊISR
 *
 * ̊荞݂3.9msԊu̕ϊ㖈Ɏn܂B]256荞ݖ1błB
 *
 * ʂ̊ev5moR53.7VŁA10.74mA̗܂B͐v
 * ŁA]āAp\Ȃǂ̇IƂׂ鎞ɾُ̇VĎ邱ƂA
 *  ߰ݽvZ邽߂ɾٓdƋɎgƂł܂B͐m
 * ÓȏZʂ߁A炩ɏ[ȇIłȂ΂Ȃ炸AȂ΁Av
 * Z傫O꓾܂BCC-ADC12ޯĔėpADCƗʰ޳ŁA]āA1
 * ̾ق̓dƕsēdsƂł邱ƂɒӂĂB
 * ŐV̒l܂LatestCCISϐ܂BӐ}͈uԂŌʾٓdƋɂ
 * ̓dߊl邱ƂłB
 *
 * ( : LatestCCIgꍇAmAɎړxȂƂĒuĂ!B)
 *
 * KvƂ1ϓd̊ƂĂg܂BZsƂȂA
 * ̒l𓾂邽߂ɂ̍s܂BmAŗp\lKvȂ߁A10{
 * ̇𒴂鎖쐬悤ɑ̍̎掎ݐςȂ΂Ȃ܂B
 * 10.74mA1v𓾂܂B10.74~16=172̎掎ݐςȂA1mA/iK̕
 * ʂ𓾂̂ɒP16ŏZ邱Ƃł܂B]āAb172̎掎
 * ܂B(:̒l͒ǉ̉ZׂȂ'Z'ʂ߂ɋ͂ɕύX邱
 * Ƃł܂B)
 *
 * ̖͍̎(1b)ɓnċϓɂ̍̎𕪎U邱ƂłBs
 * ߁A(1ޯďo͂'1'Ȃ΂̏uԂŗp\ȍ̎掎ݐς)ȒP1
 * ĳϒg܂B
 *
 * ************************************************************************** */

#define CCI_CAL 172		/* bł̗ݐςɕKvȍ̎掎 */

#pragma vector = CCADC_vect
__interrupt void CC_Instantaneous_ISR(void)
{
	static unsigned char timer = 0;			// 256荞=1b
	static signed long sl = 0;				// ݐϊ핽ω
	static unsigned char mod_remainder;		// ϒŎgp
	signed int temp,temp2;

	if(PowerMode == POWERMODE_IDLE)			// ɒds܂B
	{
		temp = CADIC;
		temp <<= 3;							// : CADIC͎ۂɕ܂13ޯĂłB
		RunningAcc += (signed long) temp;	// dԍXV
		RunningAcc += (signed long) temp;	// dԍXV
		RunningAcc += (signed long) temp;	// dԍXV
		RunningAcc += (signed long) temp;	// 4sȂ΂Ȃ܂(u~32=ݐ)B

		// : ňꂪ蓾܂A̓d܂Ȃ͂܂B
		temp2 = CADIC;
		temp = temp2;
		temp += temp2;
		temp += temp2/2;			// 10.5{A10.7{̗ǂߎ
		temp -= CCIoffset;			// ψ(̾)ZlZ
		CCarray_AddSample(temp);	// 64bύXV
		return;
	}

	// Ŏ擾ꍇAœÂ1bԕϓdlg܂B
	if(0 == ++timer)				// b1Aݐόʂo64bꗗXV
	{
		sl /= 16;					// X̉Zɑ΂Čʂ16ŏZ
		sl -= CCIoffset;			// ψ(̾)ZlZ
		CCarray_AddSample((signed int) sl);		// xꂽl𒊏o
		sl = 0;						// ݐϊ
	}

	// AŏII"sl"ݐϊϐޯē1mA̓d𐶂邽߁Ap\ȍ
	// 掎̂A̓Iɂ͂(10.74~16)ݐς܂B

	temp = mod_remainder;			// (͑iɂď޲Ă܂B)
	temp += CCI_CAL;				// ̉ZNꍇA̍̎掎g܂B
	mod_remainder = (unsigned char) temp;		// ĕۑ

	if(temp>>8)						// ꐶ?
	{
		temp = CADIC;				// ʕߑ
//		temp -= CCIoffset;			// e̎掎ψ(̾)폜Ael͂̌Ɍ݂̎g/ẐɂȂ܂B
		LatestCCI = temp;			// Lp\ȒlXV
		sl += temp;
	}
	else
		LatestCCI = CADIC;			// Lp\ȒlXV
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

/* ************************************************************************** *
 * ݌vAdISR
 *
 * ̊荞݂͕dd(CCmode()֐ɂĐݒ肳ꂽ)CADRDCڼ޽Ŏw肳
 * ꂽʂ𒴂鎞Ɏn܂BꂪnƁAтɐ؂ւ
 * Kv邱Ƃ܂B
 *
 * ************************************************************************** */

#pragma vector = CCADC_REG_CUR_vect
__interrupt void CC_RegularCurrent_ISR(void)
{
	ChangePowerMode(POWERMODE_ACTIVE,0);
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

/* ************************************************************************** *

 * ݌vAݐϊISR
 *
 *! \todo
 * ̊荞݂'Rv'֐pɏ[dW邽߂̎ȋ@\łBCCADC
 * (̾)덷ŏCȂ΂Ȃ炸Ax͌㑱vZłl
 * ׂłB
 *
 * ************************************************************************** */

//unsigned char ccindex = 0;
//long ccarray[256];

#pragma vector = CCADC_ACC_vect
__interrupt void CC_Accumulator_ISR(void)
{
	union {signed long acc; unsigned char byte[4];} lastCCreading;

//! \todo IAR3.20gꍇAȉ̍sA1֎~邱ƂKvłB
/*
  lastCCreading.byte[0] = CADAC0;		// ADClߑ
  lastCCreading.byte[1] = CADAC1;		// ADClߑ
  lastCCreading.byte[2] = CADAC2;		// ADClߑ
  lastCCreading.byte[3] = CADAC3;		// ADClߑ
*/
	lastCCreading.acc = CADAC;			// IAR 4.10Ƃȍ~ł

	lastCCreading.acc -= (signed long) CCoffset;	// CC̕ψ(̾)xˑƂ͌Ax⏞͎Ă܂B

	if(CC_delay_acc)
	{
		CC_delay_acc--;
		return;
	}

	RunningAcc += lastCCreading.acc;	// ݐϊɂ̍̎掎𕹍
}


/* =====================================================================================
   =====================================================================================
   ===================================================================================== */

/* ADCgp@̈ʓIȐ:
 *
 * ADC10̓͂܂BvɂđSقʂČpIN܂B
 * ̌A]ގɎgp҂͂̊֐Qɏ]ē̑v邱ƂłAړx
 * čZꂽl߂܂BႦ΁Axl͗ƕψ(̾)܂ADC
 * ړx܂B̾ٓdǂݍݎA͂̓قɑ΂ĕψʂƗɏ]
 * C܂B
 *
 * ٓdǂݍݎAٕtFET֎~Ă邱ƂmɂȂ΂Ȃ܂B
 *
 * Sڂ1/4000(ő1mV̌덷)žق͉̓IeʂSɏ[d̂ɕKvƂ鎞Ԃ͊T
 * (eʂ0.00Vނٓd/2ŊJn邽߂9ł͂Ȃ)8~萔łBg\ݒ
 * ł500RƋ0.1FA50s̎萔^܂B]āAǂ̾قADCق̓ǂ
 * ݊Jnɐ旧400sKvƂ܂Bɑقǂł̌ɂ̾ٓ͂ǂ
 * ƂɂĕSȂɂ̒xB܂B
 *
*/

void ADCinit(void)
{
//	char i;

	ReadFactoryCalibration();

	// : SLOW_RC_CAL͂̔U풲߂ނoߎԌvẐ߂ɌvN
	//	   オł̌vZŎg܂B
}

// ٰ݂͑S10ADCق̌pJn܂BҰ͂ǂ̻н(0`3)
// ǂނw肵܂B
void StartAdc(unsigned char select)
{
	unsigned char temp = (1<<select);

	//! \todo : ۸ޓ͂ƂADC0`3rIɎgȂꍇAȉ̺ނύXȂ΂Ȃ܂B
	DIDR0 = 0x0F;							// ADC0`3޼ٓ͊ɏՕ֎~

	PORTA &= 0xE0;
	PORTA |= (1<<4);						// PA4Highɋ쓮
	DDRA  &= 0xE0;
	DDRA  |= (1<<4) | temp;					// PA4ƑI񂾐Mo͂ɂ܂B

	VADMUX = 5;								// ŏ5
	VADCSR = (1<<VADEN) | (1<<VADCCIF);		// ǂۗ̕荞݂
	VADCSR = (1<<VADEN) | (1<<VADSC) | (1<<VADCCIE);	// ŏ̕ϊJnƊ荞݋
}

// SADCقʂĎIɑ
// S10sƁÅ荞݂͎g֎~܂B
#pragma vector = VADC_vect
__interrupt void ADC_INT(void)
{
	unsigned char temp;
	static char counter;				// EغݏQ̂ߒǉ

	temp = VADMUX;

	ADCbuffer[temp-1] = VADC;			// ʕۑ

	if((temp <= 4) && (temp >= 1))		// Pɾٓǂݍ?
		cell_current[temp-1] = LatestCCI;	// Ɋ֘A߰ݽpCCIlۑ

	if(temp == 5) {						// ɂ𓾂OɌv
		counter = VPTAT_READINGS;		// EغݏQp
		temp++;
	}

	if((temp == 6)||(temp == 7)) {		//
		if(--counter == 0) {			// VPTATҋ@AEغݏQp
			temp++;
			counter = ADC0_READINGS;	// VPTATǂݎVREFҋ@
		}
	} else {
		temp++;
		if(10 == temp) {				// ł\8Ałx10A葁ꍇ͏6/7IfgĂB
			DisableCellBalancing();		// 519szKvƂꍇA10sƂł܂!B
		} else {
			if(10 < temp) {				// 1`4Ōp?
				temp = 1;
			} else {
				if(5 == temp) {	  		// Sّ?
					SetADCScanDone;		// V̎掎Ƃ׸
					EnableCellBalancing();
					VADCSR = 0;			// ADCƂ̊荞݂֎~
					return;
				}
			}
		}
	}

	VADMUX = temp;
	VADCSR |= (1<<VADSC);				// ⎟̕ϊJn
}

// main()Ă΂ׂłBADCA͐VʂvZ܂B
// ͻнԋ@\Ԃm邱ƂKvłB
void CalculateADCresults(void)
{
	unsigned long calc;
	unsigned char index;
//	unsigned int fixedV;
	unsigned int thermV;

	// VٓdvZ
	for(index = 0; index < PACKSTACK; index++)
	{
		calc = ADCbuffer[index]<<2;
		calc = calc * ADCgain[index];
		calc >>= 16;
		CellV[index] = (unsigned int)(calc);
		if((unsigned int)calc < CELL_TOOLITTLEV)
			DoShutdown(SHUTDOWN_REASON_UNDERVOLTAGE);		// قrȍꍇɒ~֍s
		if((unsigned int)calc > CELL_TOOMUCHV)
			DoShutdown(SHUTDOWN_REASON_OVERVOLTAGE);		// قt̏ꍇɒ~֍s
	}

	//! \todo  ߰ݽfړIpcell_current[]ŉs߁Aɺ
	//!		  ǉ邱Ƃł܂B

	// ̖0.2~̎ړxŴ߂ɐVADC4(PA4)lvZ
	calc = ADCbuffer[4];
	calc = calc * 344;
	VPA4 = (unsigned int) (calc >> 8);

	// ߏ㉷xvZBZ10{𓾂悤ɁA\VTgain2.5{Ɏړxg債
	// Ă̌ADCbuffer[6]4{Ŏړx悤ɁAœK@
	// 邩܂B̌Ɍʂ2ŏ㏸ړǍɌʂƂď
	// 2޲Ă邱Ƃł܂BVTgain2.5{ĖINTɍ͊mł
	// ܂B̍œKsƁAZߖ񂵂܂B
	calc = ADCbuffer[5];
	calc = calc * VTgain;							// 'K~2^14^܂B
	OnChipTemp = (unsigned int) (calc / 1638);		// 0.1'K𓾂邽߂(2^14/10)ŏZ

	// ׂ̻н̌ʂXV
	index = ThermistorSelect;						// ThermistorSelect͂ǂ̏o͂Low܂B
	index++;										// ق֍sȂl𒆓_ƂĎgĂB
	index &= 0x03;
	thermV = ADCbuffer[index+7];
	Thermistor[ThermistorSelect] = thermV;
}

// 0.1݉xߏ㉷xԂ܂B
// нRl𒼐ڃŕԂ܂(KvƂ鎞ɂύXĂ)
// : 0=ߏ; 1`4 = PA0-3н
unsigned int ReadTemperature(unsigned char channel)
{
	if(0 == channel)
		return OnChipTemp;

//	temperature = ADCbuffer[6] * VTgain;
//	temperature = temperature / 1638;		// =16384/10
//	temperature -= 2731;					// 'K灎ɕϊ(0=273.15K)
//	return (unsigned int) temperature;


	if(channel > 5)
		return 0;							// ]ވُlIłB

	//! \todo dlxɕϊvZɑ}ĂB
	return Thermistor[channel-1];			// ̂ƂA[KVADČʂԂ܂B
}

// ٓdmV(ɐ)ŕԂ܂(=1`4)B
unsigned int ReadCell(char cell)
{
	if((cell == 0) || (cell > 4))
		return 0;

	return CellV[cell-1];
}

void DisableCellBalancing(void)
{
  CBCR = 0;
}

void EnableCellBalancing(void)		// CellToBalance=0̏ꍇAtvȂ
{
	if(CellToBalance)
	{
		CBCR = (1<<(CellToBalance-1));
	}
	else
		CBCR = 0;
}
