// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: bootldr.h
* - ߲		: IAR EWAAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - dr/ATAVRSB100
*
* - 		: bootloader_smbus.cpͯ ̧
*				  ϐA֐ȂǗp`
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:38 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

// ^錾

#define SMBvariables	SV.SMBvar
#define SMBvar_int		SV.SMBint

#define HOST_ADDR		0x10
#define CHARGER_ADDR	0x12
#define BATTERY_ADDR	0x16

// ȉ̖(cmd)[dւ̎呕u݂Ə]uǂݍ݂̗ł邱ƂɒӂĂB
#define SMB_M_CMD_CHARGINGCURRENT	0x14
#define SMB_M_CMD_CHARGINGVOLTAGE	0x15

// ̖߂͏[dν ڽ̗ւ̎呕u݂łB
#define SMB_M_CMD_ALARMWARNING		0x16

// SMBusϐ + ߖψʈꗗ
#define SMBV_MfrAccess		 0
#define SMBV_RemCapAlm		 1
#define SMBV_RemTimeAlm		 2
#define SMBV_BattMode		 3
#define SMBV_AtRate			 4
#define SMBV_AtRateTTF		 5
#define SMBV_AtRateTTE		 6
#define SMBV_AtRateOK		 7

#define SMBV_Temperature	 8
#define SMBV_Voltage		 9
#define SMBV_Current		10
#define SMBV_AvgCurrent		11
#define SMBV_MaxError		12
#define SMBV_RelSOC			13
#define SMBV_AbsSOC			14
#define SMBV_RemCap			15

#define SMBV_FullChgCap		16
#define SMBV_RunTTE			17
#define SMBV_AvgTTE			18
#define SMBV_AvgTTF			19
#define SMBV_ChgCurrent		20
#define SMBV_ChgVoltage		21
#define SMBV_BattStatus		22
#define SMBV_CycleCount		23

#define SMBV_DesignCap		24
#define SMBV_DesignVolt		25
#define SMBV_SpecInfo		26
#define SMBV_MfrDate		27
#define SMBV_SerialNo		28

#define SMBV_MfrName		32
#define SMBV_DeviceName		33
#define SMBV_DeviceChem		34
#define SMBV_MfrData		35
#define SMBV_Opt5			0x2F
#define SMBV_Opt4			0x3C
#define SMBV_Opt3			0x3D
#define SMBV_Opt2			0x3E
#define SMBV_Opt1			0x3F

// 29SMBusϐvf̊eX̕ψ
#define lobyte				0
#define hibyte				1

// TW_RxBuf[]̕ψ
#define TWRX_BLKCNT			2	/* ̑Mł̎c޲Ă̗ */
#define TWRX_CMD			3	/* s薽ߗp׸ */
#define TWRX_MEM			4	/* ǂ؋Ԃ׸ */
#define TWRX_OFFSET			5	/* ްpSRAMɏՕւ̕ψ */
#define TWRX_LOADDR			6	/* ؋Աڽ޲ */
#define TWRX_HIADDR			7	/* ؋Աڽ޲ */
#define TWRX_SIZE			8	/* 㑱ް̑傫 */
#define TWRX_DATA			9	/* ݂ꍇAް̐擪 */

// SMBV_BatteryModeޯĒ`

// ޲
#define CHARGE_CONTROLLER_ENABLED	0x01
#define PRIMARY_BATTERY				0x02
#define ALARM_MODE					0x20
#define CHARGER_MODE				0x40
#define CAPACITY_MODE				0x80

// ޲
#define INTERNAL_CHARGE_CONTROLLER	0x01
#define PRIMARY_BATTERY_SUPPORT		0x02
#define CONDITION_FLAG				0x80

//SMBV_BatteryStatusޯĒ`

// ޲
/* * * * * * xޯ * * * * */
#define OVER_CHARGED_ALARM			0x80
#define TERMINATE_CHARGE_ALARM		0x40
#define OVER_TEMP_ALARM				0x10
#define TERMINATE_DISCHARGE_ALARM	0x08
#define REMAINING_CAPACITY_ALARM	0x02
#define REMAINING_TIME_ALARM		0x01

// ޲
/* * * * * * ޯ * * * * */
#define INITIALIZED					0x80
#define DISCHARGING					0x40
#define FULLY_CHARGED				0x20
#define FULLY_DISCHARGED			0x10

/* * * * * * ُ필 * * * * */
#define SMBerr_OK					0x00	// R/W:dr͂ǂُ̈oɋ@\܂B
#define SMBerr_Busy					0x01	// R/W:dr͌_Ŋ֐邱Ƃł܂B
#define SMBerr_ReservedCommand		0x02	// R/W:dr͂̔ł̎dlŗ\񂳂ꂽ@\ւ̓ǂ݂܂͏݂̎
											//     o܂Bdr͖x̔CӑI𐻑Ǝҋ@\݂̎
											//     o܂B
#define SMBerr_UnsuptdCommand		0x03	// R/W:dr͂̔ł̎dlŒ`ꂽ̋@\x܂B
#define SMBerr_AccessDenied			0x04	//  W :dr͓ǂݍݐp@\ւ݂݂̏̎o܂B
#define SMBerr_OverUnderflow		0x05	// R/W:drް̉ߑߏo܂B
#define SMBerr_BadSize				0x06 	//  W :dr͕sȑ傫ްŋ@\ւ݂݂̏̎o
											//     B
#define SMBerr_UnknownError			0x07 	// R/W:dr͗\ُo܂B
