// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: main.c
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - drQƊ݌v
*
* - 		: 
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:40 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

/*! \mainpage
* ATAVRSB100pĳ̊֐AϐA^`A񋓁A񋓎qA`𕶏ɋL^
* ܂B\n
* ُ߲AJL^Aׂꗗ̊֘AłB
*/

/*! \page doc_page1 ُ߲
* \section section 忰
* ̿ĳIAR Embedded Workbench 4.11A/4.10Bpɏ܂A3.20Cg
* č\z邱Ƃł܂(Xɉ̋Lڂ)B\n
* ۼުĂ쐬ɂ:
* .ç(main.c, gpio.c, main.c, pwrmgmt.c, safety.c, smbus.c, timer.cłA
* ް۰ނbootloader_smbus.c͈Ⴂ܂)ۼުĂɒǉA޲--cpu=m40A
* CLIB˰߂̑傫0x80Aް (CSTACK)0x80޲āA߂ڽ (RSTACK)
* 64قgAI/Oݸٰ ̧قłޯĒ`AœKAo͌`:ޯޗp
* ubrof8AJpintel_extendedgĂB\n
* IAR EWAVR 3.20gꍇA\ݒ-v3gA(Ƌɲݸٰނ̧
* ق)$PROJ_DIR$\\cfgm406s.xclŊݶ̧ق㏑ĂBanalog.c
* ҏW邱ƂKvł(CC_Accumulator_ISR(void)todo)B
*/

/*! \page doc_page2 JL^
* ̿ ނbȂƂɒӂĂB̌JłATmega406EΏ
* ƂAATmega406̋ł͎x܂Bȉ̋@\͊SɎĂȂA
* ܂͊SɊmFĂ܂B\n
*  - drق̉xĎ͒ǉ̺ނKvƂ܂B\n
*  - ް۰ލXV̂߂ɈÍǉ邩܂񂪌ݖłB\n
*/

//#include "iom406_320.h"
#include <iom406.h>		// ATmega406pIAR(EW 410)ͯ ̧
#include <inavr.h>

#define MODULE_MAIN
#include "main.h"
#include "analog.h"
#include "calibration.h"
#include "timer.h"
#include "pack.h"
#include "smbus.h"
#include "gpio.h"
#include "safety.h"
#include "pwrmgmt.h"
#include "ee.h"

// Ǐ^錾
void BalanceCheck(void);
void ChargeCheck(void);
void ThermalCheck(void);
void AlarmModeDisabledCheck(void);
void AlarmConditionsCheck(void);
void MasterSMBusCheck(unsigned char ResetTimer);
void SleepMgr(void);
void WdogMgr(void);
void DoCalibrate(void);


void InitAll(void)
{
	InitSMBus();							// dl1msNKvƂ邽߂ŏɏ!

//! \todo ŏIނɑ΂ĳޯނċĂB
//! WQȂޯނ߂ɂł͂ꂪ֎~܂B
//
//	Wdog_init(WDOG_MODE_RSTINT, WD1sec);	// xᑬɐݒ

	PinInit();								// I/O
	T0init();
	T1init();
	PBinit();								// t荞݊
	CCinit();
	ADCinit();
	HWProtectinit();
	InitSMBvariables();
}

unsigned char qtrsectick = 3;
unsigned char AlarmModeDisabledTimer = 0;

//#pragma object_attribute=__c_task
void main(void)
{
	InitAll();
	ChangePowerMode(POWERMODE_POWERSAVE,0);
	__enable_interrupt();

	LEDs = 0x1f;

	for(;;)
	{
		if(action_flags)	// ׂ𒲍
		{
			if(CheckCalibRequest)
			{
				ClrCalibRequest;
				DoCalibrate();							// vꂽZs
			}

			if(CheckADCScanDone)
			{
				ClrADCScanDone;

				// VVADClp\ɊT1b1񑖍s
				CalculateADCresults();					// ADC̎悩ړxꂽʂ𐶐
				BalanceCheck();							// ǂꂩٕ̾tsƂKv𒲍
				ChargeCheck();							// [dĎ
				ThermalCheck();							// xߏԊւ
				AlarmModeDisabledCheck();				// x񓮍ċpvJn
				AlarmConditionsCheck();					// xɊ֘Aǂꂩ̗eʂ݂邩𒲍
				MasterSMBusCheck(0);					// ̑oKv𒲍
			}

			if(CheckQtrSec)
			{
				ClrQtrSec;
				SetGenericTimer(OneQtrSecond, 244);

				WdogMgr();

				// 32kHz͐VK̎nݸނ
				if(Timer32KHz)
				{
					if(--Timer32KHz == 0)
						CCSR = ((1<<XOE)|(1<<ACS));
				}

				if(++qtrsectick >= 4)
				{ // b1ȉs
					qtrsectick = 0;
					ThermistorSelect++;
					ThermistorSelect &= 0x03;
					StartAdc(ThermistorSelect);
				}
			}

			if(CheckAlarmMode)							// ޯĂONȂAċ邽߂60bvJn
			{
				ClrAlarmMode;							// BATTERY_MODEޯĂł͂ȂA׸ނ
				AlarmModeDisabledTimer = 0;				// 60bv
			}

			if(CheckMasterSMBdone)
			{
				ClrMasterSMBdone;
				SMBvariables[SMBV_BattStatus][lobyte] &= ~(0x0F);	// Mُ̈필
				MasterSMBusCheck(1);				   	// үތvؾ
			}
		}
		else	// ActionFlagޯĂݒłȂꍇ
		{
			if(!GetGenericTimer(OneQtrSecond))			// ͂ڂɓׂł!B
				SetGenericTimer(OneQtrSecond, 244);		// ꂪ~ꂽꍇ250msvĎn!
		}

		SMB_CmdInterpreter();							// M߂邩𒲍
		Check50uS();									// ޽ߑ݂邩ǂ𒲍
		SetLEDs(LEDs);									// ]ގ͏ҰύX

//		SleepMgr();										//! \todo ޯޖړÎ߂ɋ֎~܂B

	}
}

// ʾّlƂ炪Ă邩
void BalanceCheck(void)
{
	unsigned int Vmax = ReadCell(1);
	unsigned int temp;
	unsigned char maxcell = 1;
	unsigned char delta = 0;

	// ŏɂǂ̾قōłǂ̈ʂ𔻒f
	temp = ReadCell(2);
	if(temp > Vmax)
	{
		delta += (temp - Vmax);
		Vmax += delta;
		maxcell = 2;
	}
	else
	if(temp < (Vmax - delta))
	{
		delta = (Vmax - temp);
	}

	if(PACKSTACK > 2)				// pack_cfg.hłB
	{
		temp = ReadCell(3);
		if(temp > Vmax)
		{
			delta += (temp - Vmax);
			Vmax += delta;
			maxcell = 3;
		}
		else
		if(temp < (Vmax - delta))
		{
			delta = (Vmax - temp);
		}
	}

	if(PACKSTACK > 3)
	{
		temp = ReadCell(4);
		if(temp > Vmax)
		{
			delta += (temp - Vmax);
			Vmax += delta;
			maxcell = 4;
		}
		else
		if(temp < (Vmax - delta))
		{
			delta = (Vmax - temp);
		}
	}

	// Aǂ̾قōŁA͉Ȃ̂m܂B

	// st[ꍇAtJn
	if(delta > MAX_IMBALANCE)
	{
		CellToBalance = maxcell;	// ǂ̾قōۑ
		EnableCellBalancing();
	}
	else	// tOFFȂƂۏ
	{
		CellToBalance = 0;			// sȂ΂Ȃ܂BISR͕tA
		DisableCellBalancing();		// ̂ɂ0̂܂܂ɂꍇAtĂїLɂȂ܂B
	}
}

void ChargeCheck(void)			// [dĎ
{
	signed int cell = (signed int) ReadCell(1);		// ۂɂ͂ǂ̾قł܂܂B
	unsigned char charge_percent;

	// ŏɓdɊÂ]
	if(cell >= CELL_NOMINALV)
	{
		if(SMBvariables[SMBV_BattStatus][lobyte] & FULLY_CHARGED)	// ɂ̓_ɓB?
		{
			if(Current1Sec() < 0)	// dJn?
			{
				SMBvariables[SMBV_BattStatus][lobyte] |= DISCHARGING;
				FCSR = (1<<DFE) | (1<<CFE);		// FET
			}
			else	// dȂ
			{
				if((cell >= CELL_TOOMUCHV) && (Current1Sec() > 0))	// ܂[d?
				{
					FCSR = (1<<DFE) | (1<<PFD);	 // [d~(޲ނʂĖ[d邱Ƃł܂B)
				}
			}
		}
		else	// tԂ̏o
		{
			FullChargeReached();	// eʒlXV
			SMBvariables[SMBV_BattStatus][lobyte] |= FULLY_CHARGED;

			if(Current1Sec() > 0)	// [d
			{
				SMBvariables[SMBV_BattStatus][hibyte] |= TERMINATE_CHARGE_ALARM;
				SMBvariables[SMBV_BattStatus][hibyte] |= OVER_CHARGED_ALARM;
			}
		}
		return;						// XȂǂ̌̑sזĂ͂Ȃ܂!B
	}
	else
	if(cell <= CELL_MINV)
	{
		if(SMBvariables[SMBV_BattStatus][lobyte] & FULLY_DISCHARGED)	// ɂ̓_ɓB?
		{
			if(Current1Sec() > 0)				// ɏ[dJn?
			{
				SMBvariables[SMBV_BattStatus][lobyte] &= ~DISCHARGING;
				FCSR = (1<<DFE) | (1<<CFE);		// FET
			}
			else	// [dȂ
			{
				if((cell <= CELL_TOOLITTLEV) && (Current1Sec() < 0))	// d?
				{
					FCSR = 0;			// [dFETOFFA\[dFET
					SMBvariables[SMBV_BattStatus][hibyte] |= TERMINATE_DISCHARGE_ALARM;
					SMBvariables[SMBV_BattStatus][lobyte] |= DISCHARGING;
				}
			}
		}
		else	// Ԃ̏o
		{
			FullDischargeReached();		// eʒlXV
			SMBvariables[SMBV_BattStatus][lobyte] |= FULLY_DISCHARGED;
			SMBvariables[SMBV_BattStatus][hibyte] |= TERMINATE_DISCHARGE_ALARM;
		}
		return;					// XȂǂ̌̑sזĂ͂Ȃ܂!B
	}
	else
	{
		FCSR |= (1<<DFE) | (1<<CFE) | (1<<PFD);
	}

	// ɁAߏɑ΂[dd
	charge_percent = RelativeSOC();
	cell = Current1Sec();		// ͕dA͏[dӖ܂B
	if(cell <= 0)				// d(ȕd̂0܂܂܂B)
	{
		cell = -cell;

		// DISCHARGING׸ނLɂȂ΂Ȃ܂B
		SMBvariables[SMBV_BattStatus][lobyte] |= DISCHARGING;

		// dȂA[dx׸ނɉ
		SMBvariables[SMBV_BattStatus][hibyte] &= ~TERMINATE_CHARGE_ALARM;

		// FULLY_CHARGED׸ނ𖢂ׂ
		if(charge_percent < 99)
			SMBvariables[SMBV_BattStatus][lobyte] &= ~FULLY_CHARGED;

		// dIKv(ޯD11)
		if((cell > PACK_DISCHG_MAX) || (charge_percent == 1))
			SMBvariables[SMBV_BattStatus][hibyte] |= TERMINATE_DISCHARGE_ALARM;
		else
			SMBvariables[SMBV_BattStatus][hibyte] &= ~TERMINATE_DISCHARGE_ALARM;

		// : ٓdŏٓdȉɗ(charge_percent=0)łȂ΁AǏ
		//	   IɂOFFɂ܂B̗R͒`ɂčŏdɗ
		//	   œdr߯SɋɂȂ߂łBcharge_percent*s*
		//	   ɂȂ蓾ĖZɂ邩܂B
	}
	else	// [d
	{
		// [dAdx׸ނɉ
		SMBvariables[SMBV_BattStatus][hibyte] &= ~TERMINATE_DISCHARGE_ALARM;

		// ]āADISCHARGING׸ނł܂B
		SMBvariables[SMBV_BattStatus][lobyte] &= ~DISCHARGING;

		// FULLY_DISCHARGED׸ނ𖢂ł邩
		if( (SMBvariables[SMBV_BattStatus][lobyte] & FULLY_DISCHARGED) &&
			(charge_percent > 20) )
			SMBvariables[SMBV_BattStatus][lobyte] &= ~FULLY_DISCHARGED;

		if(cell == 0)	// [ddȂ?
		{	// d0܂܂邽߁A݂͖B
			SMBvariables[SMBV_BattStatus][hibyte] &= ~TERMINATE_CHARGE_ALARM;
			SMBvariables[SMBV_BattStatus][hibyte] &= ~OVER_CHARGED_ALARM;
		}
		else	// [d
		{
			// [dI(ޯD14)
			if((cell > PACK_MAX_CHG_C) || (charge_percent >= 100))
				SMBvariables[SMBV_BattStatus][hibyte] |= TERMINATE_CHARGE_ALARM;
			else
				SMBvariables[SMBV_BattStatus][hibyte] &= ~TERMINATE_CHARGE_ALARM;

			// ߏ[d?
			if(charge_percent >= 100)
				SMBvariables[SMBV_BattStatus][hibyte] |= OVER_CHARGED_ALARM;
			else
				SMBvariables[SMBV_BattStatus][hibyte] &= ~OVER_CHARGED_ALARM;
		}
	}

	//! \todo 2{̗eʂdr߯ɏo܂͓ꂷ鎞͕KCycleCountϐ
	//!		  ₷Ǝv܂BtƋ̗xɓĂ͂Ȃ܂B
	//
	// if(???)
	//     SMBvar_int[SMBV_CycleCount]++;
}

void ThermalCheck(void)
{
	unsigned int temp = GetTemperature();

	// xߌx񒲍(ޯD12)
	if(temp > MAX_CELL_TEMPERATURE)
		SMBvariables[SMBV_BattStatus][hibyte] |= OVER_TEMP_ALARM;
	else
		SMBvariables[SMBV_BattStatus][hibyte] &= ~OVER_TEMP_ALARM;

	// ν/[d킪[ȂꍇɋǏIɎՒf
	if(temp > MAX_ONCHIP_TEMP)
		DoShutdown(SHUTDOWN_REASON_OVERTEMPERATURE);

//! \todo ȉ̾ىx͂ꂪ軰нIgp҂ɔC邽ߋ֎~
//!		  B

/*
	if(ReadTemperature(1) > MAX_CELL_TEMPERATURE)
		;

	if(ReadTemperature(2) > MAX_CELL_TEMPERATURE)
		;

	if(PACKSTACK <= 2)
		return;
	if(ReadTemperature(3) > MAX_CELL_TEMPERATURE)
		;

	if(PACKSTACK <= 3)
		return;
	if(ReadTemperature(4) > MAX_CELL_TEMPERATURE)
		;
*/

}

// ͌x񓮍͍ő60bԂ֎~邱Ƃۏ؂܂B
void AlarmModeDisabledCheck(void)
{
	if(SMBvariables[SMBV_BattMode][hibyte] & ALARM_MODE)
	{
		if(++AlarmModeDisabledTimer >= 59)
		{
			SMBvariables[SMBV_BattMode][hibyte] &= ~ALARM_MODE;		// ċ
		}
	}
}

void AlarmConditionsCheck(void)		// ''̌x󋵂T܂B
{
	// c莞(ޯD8)
	if(SMBvar_int[SMBV_RemTimeAlm] != 0)
	{
		if(TimeToEmpty(0) < SMBvar_int[SMBV_RemTimeAlm])
			SMBvariables[SMBV_BattStatus][hibyte] |= REMAINING_TIME_ALARM;
	}
	else
		SMBvariables[SMBV_BattStatus][hibyte] &= ~REMAINING_TIME_ALARM;

	// ce(ޯD9)
	if(SMBvar_int[SMBV_RemCapAlm] != 0)
	{
		if(RemainingCap() < SMBvar_int[SMBV_RemCapAlm])
			SMBvariables[SMBV_BattStatus][hibyte] |= REMAINING_CAPACITY_ALARM;
	}
	else
		SMBvariables[SMBV_BattStatus][hibyte] &= ~REMAINING_CAPACITY_ALARM;

}

void MasterSMBusCheck(unsigned char ResetTimer)		// (ResetTimerL)1b1Ă΂܂B
{
	static unsigned char timer = 0;

	// SMB_Master()ĂԎɊɏՕɉꍇ͑MłB
	// 𐧌䂷邽߁AꂪŏInn>10b̏ꍇɂ}

	if(ResetTimer)
	{
		timer = 0;
		return;
	}

	if(++timer < 10)
	{
		SMB_Master();
		return;
	}

	if(!(SMBvariables[SMBV_BattMode][hibyte] & ALARM_MODE))
	{
		// ASAPɑȂ΂ȂȂVXVꂽdr󋵂邩
		if(SMBvariables[SMBV_BattStatus][hibyte])
		{
			if(SMBvariables[SMBV_BattStatus][hibyte] & ~(REMAINING_CAPACITY_ALARM | REMAINING_TIME_ALARM))
			{	// үނνĂƏ[d̗ɑ邱ƂKv
				MasterInsertMsg(CHARGER_ADDR, SMB_M_CMD_ALARMWARNING, SMBvar_int[SMBV_BattStatus]);
			}
			// SĂүނνĂɑ܂B
			MasterInsertMsg(HOST_ADDR, SMB_M_CMD_ALARMWARNING, SMBvar_int[SMBV_BattStatus]);
		}

		//! \todo Ɋ{Iȏ[dZ@܂B߂̂ɏ[dԂg܂B
		//!		  Ɛꂽ[dZ@̂͐݌vҎłB

		if(!(SMBvariables[SMBV_BattMode][hibyte] & CHARGER_MODE))	// CHARGER_MODEAsbdat110, 5.1.4
		{
			if(!(SMBvariables[SMBV_BattStatus][lobyte] & FULLY_CHARGED) ||
			   !(SMBvariables[SMBV_BattStatus][hibyte] & TERMINATE_CHARGE_ALARM) ||
			   !(SMBvariables[SMBV_BattStatus][hibyte] & OVER_CHARGED_ALARM)) {		// [dOK?

				SMBvar_int[SMBV_ChgCurrent] = PACK_CCCV_C;
				SMBvar_int[SMBV_ChgVoltage] = PACK_CCCV_V;
				MasterInsertMsg(CHARGER_ADDR, SMB_M_CMD_CHARGINGCURRENT, PACK_CCCV_C);
				MasterInsertMsg(CHARGER_ADDR, SMB_M_CMD_CHARGINGVOLTAGE, PACK_CCCV_V);
			} else { // [dOKł͂܂B
				SMBvar_int[SMBV_ChgCurrent] = 0x0000;
				SMBvar_int[SMBV_ChgVoltage] = 0x0000;
			}
		}

		timer = 0;		// ͓̉үނMɏՕɌJԂǉ̂h܂B
	}

	SMB_Master();
}

void SleepMgr(void)
{
	SMCR |= (1<<SE);
	__sleep();
	__no_operation();
	__no_operation();
	__no_operation();
	__no_operation();

	// ̓_ŋx~ׂłB

	// `

	// ̓_ŁANオ点̊荞݂ɑ΂ISȒsPɊ܂B
	SMCR &= ~(1<<SE);	// ްĂɏ]ANオSEޯĂׂłB
	return;				// JԂɖ߂AĂыx~OɉɍsƂKv𒲍
}

void WdogMgr(void)
{
	//! \todo ̺ނͳޯނɌpIɗ^邱Ƃ̖\h߂ɂ
	//		  Ɛ邱Ƃł܂B

	__watchdog_reset();

	return;
}

void DoCalibrate(void)
{
	// DoCalibrateٰ݂̐:
	// gp҂͓K؂ޯĐݒŌꏑSMBus߂0x3C(OptionalMfgFunction4)
	// 𑗂邱ƂɂČv܂Baction_flagsCALIBREQUESTED
	//  ޯĂݒ肵A'calibration_state_req'ϐM܂݂܂B
	// OptionalMfgFunction4ǂݍ݂'calibration_state'ϐɊ܂܂錻݂̏
	// ԂԂ܂B
	//
	// ϐ͗ɍv8̍Zٰ݂̏ꏊ2ޯė̈ɕ܂B
	// ͉޲Ă̍ŉ4ޯĂ2̍Zٰ݂܂B
	// xx xx xx xx xx xx BB AA.
	//
	// xx = gpޯāA00
	// AA = VREFZ̏
	// BB = ݌vψ(̾)Z̏
	//
	// ԕ:
	// 00 - ZȂ/Z͗vĂ܂B
	// 01 - Zis/Zv܂B
	// 10 - Zs/Z폜v
	// 11 - ZOK/ZsŗLl݂ȂAZɖ߂AłȂ΁AZ
	//		ȂԂ܂B
	//
	// ԑJڂ̏ڍׂɂĂ͎̍\}BsZ͒l
	// AtmelHؾĂ܂AlEEPROM̂߁AؾĂ͂ǂ
	// calibration_stateZOKɐݒ肵܂BZOKł݂̏͂
	// ėLȍZl𕜌ďԂZOKɐݒ肷邩A܂͗LȒl
	// ꍇɍZȂɐݒ肵܂B
	// : Zsł݂̏͒O̍Zl폜܂B

	unsigned char state, request;
	unsigned int backup_state_req = calibration_state_req;

	state = ((calibration_state & CAL_VREF_MASK) >> CAL_VREF_BIT_POS);
	request = ((backup_state_req & CAL_VREF_MASK) >> CAL_VREF_BIT_POS);
	switch(request) {
		case RUN_CAL:		// Zv
			__disable_interrupt();
			DisableCellBalancing();
			calibration_state &= ~CAL_VREF_MASK;		// ޯĉ
			calibration_state |=  CAL_VREF_RUN;			// Ԃs(RUN)ɐݒ
			if(CalibrateVREF()) {				// ZOK?
				calibration_state &= ~CAL_VREF_MASK;	// ޯĉ
				calibration_state |=  CAL_VREF_OK;		// ԂOKɐݒ
				__enable_interrupt();
			} else {
				calibration_state &= ~CAL_VREF_MASK;	// ޯĉ
				calibration_state |=  CAL_VREF_FAIL;	// Ԃs(FAIL)ɐݒ
				__enable_interrupt();
			}
			EnableCellBalancing();
			break;
		case CAL_FAIL:		// Z폜
			if (state == NO_CAL) {	// NO_CALԂɊ֘A܂B
				break;
			} else {				// Z萔폜
				do {} while(EECR & (1<<EEPE));
				do {} while(SPMCSR & (1<<SPMEN));
				EEAR = EESTORAGE_BGCCR;
				EEDR = 0xFF;
				EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	// arm
				EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	// go
				calibration_state &= ~CAL_VREF_MASK;		// ޯĉ
				ReadVrefCalibration();
			}
			break;
		case CAL_OK:		// LȒl݂ȂAEEPROMl
			if (state == CAL_FAIL) {	// CAL_FAILԂ炾L
				if (ReadVrefCalibration()) {
					calibration_state &= ~CAL_VREF_MASK;	// ޯĉ
					calibration_state |=  CAL_VREF_OK;		// ԂOKɐݒ
				} else {
					calibration_state &= ~CAL_VREF_MASK;	// ޯĉ
				}
			}
			break;
		default:
			break;
	}

	state = ((calibration_state & CAL_CC_MASK) >> CAL_CC_BIT_POS);
	request = ((backup_state_req & CAL_CC_MASK) >> CAL_CC_BIT_POS);
	switch(request) {
		case RUN_CAL:		// Zv
			__disable_interrupt();
			calibration_state &= ~CAL_CC_MASK;			// ޯĉ
			calibration_state |=  CAL_CC_RUN;			// Ԃs(RUN)ɐݒ
			if(CalibrateCCoffset()) {	// ZOK?
				calibration_state &= ~CAL_CC_MASK;		// ޯĉ
				calibration_state |=  CAL_CC_OK;		// ԂOKɐݒ
				__enable_interrupt();
			} else {
				calibration_state &= ~CAL_CC_MASK;		// ޯĉ
				calibration_state |=  CAL_CC_FAIL;		// Ԃs(FAIL)ɐݒ
				__enable_interrupt();
			}
			break;
		case CAL_FAIL:		// Z폜
			if (state == NO_CAL) {		// NO_CALԂɊ֘A܂B
				break;
			} else {					// LZ폜
				do {} while(EECR & (1<<EEPE));
				do {} while(SPMCSR & (1<<SPMEN));
				EEAR = EESTORAGE_CC_valid;
				EEDR = 0xFF;
				EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	// arm
				EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	// go
				calibration_state &= ~CAL_CC_MASK;		// ޯĉ
				ReadCCOffsetCalibration();
			}
			break;
		case CAL_OK:		// LȒl݂ȂAEEPROMl
			if (state == CAL_FAIL) {	// CAL_FAILԂ炾L
				if (ReadCCOffsetCalibration()) {
					calibration_state &= ~CAL_CC_MASK;	// ޯĉ
					calibration_state |=  CAL_CC_OK;	// ԂOKɐݒ
				} else {
					calibration_state &= ~CAL_CC_MASK;	// ޯĉ
				}
			}
			break;
		default:
			break;
	}
}

/* e핶

ٕt
1b1ASĂ̾ٓd̑s܂BǂA̎ɾٕtFET
ꍇA炪dז܂B߁AVADC ISR͑̊ԁA
tFETՒf܂(1mVւ̈̂߂̓RChgɑ΂ď\)Bٓd
̊ŁAقtꍇAtFETIɍċ܂B

߰ݽ
ق̲߰ݽ𑪒肷邽߁Aق̓d͏udƓɑ肳Ȃ΂Ȃ܂
B]āAeق̓dϊN鎞ɑΉudl̕
cell_current[4]zɊi[܂B{ٰ݂͂̌ɓK؂Ȏɂް
Ƃł܂B4̌ʕ;ٓdǂݎ葖̊ԂCCADCu荞݂N
ꍇɕۑ܂B

*/
