// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: timer.c
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - drQƊ݌v
*
* - 		:vٰ
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:42 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

//#include "iom406_320.h"
#include <iom406.h>		// ATmega406pIAR(EW 4140)pͯ ̧

#define MODULE_TIMER
#include "timer.h"

#include "main.h"		// action_flagsp
#include "smbus.h"
#include "inavr.h"
#include "pwrmgmt.h"	// x~`p
#include "analog.h"     // RunningAccւ̱p
#include "pack.h"


/* ****************************************************************************
 *
 * v̎g:
 *
 * T0: e@\
 *     1. ʌvp̊{x
 *     2. T0CMPA͔CӑILED PWM@\
 *     3. T0CMPB͏[dFET PWM
 *   T0pۯ͎ۯ1MHzłB]āAOu킪1̏ꍇA
 *   1MHz/256=3.9kHz=256słB
 *   ʏ퓮ɑ΂ĂCMPSłLEDƌv퍏ƂĂ̗̈KvłB
 *   ]đOu=8g܂B2.048msƑS5LEDɓn100kHz
 *   XVx𐶂܂BႦꂪgĂȂĂAFETpPWM͂̐݌vŗ
 *   p\łB
 *
 * T1: ̐݌vł͕sgp
 *
 * ****************************************************************************/

void T0init(void)
{
	DDRB |= (1<<6);		// PB6o͂OC0AƂď
	TCCR0A = (1<<COM0A1) | (0<<COM0A0) | (1<<WGM01) | (1<<WGM00);
	TCCR0B = 2;			// Ou=8
	OCR0A = 192;		// pg`邱Ƃł悤75%Pxgp
	OCR0B = 0;			// FETɂPWMgpɗp\

	TIFR0 = 7;			// Sv튄荞ݗv׸ނ
	TIMSK0 = (1<<OCIE0A) | (1<<TOIE0);	// KvƂ邽ߊ荞݋
}

void SetLEDbrightness(unsigned char value)
{
	// Ɉꊄ荞݂ƂԂȂ悤ALEDPx250ȂłB
	if(value <= 250)
		OCR0A = value;
	else
		OCR0A = 250;
}

void SetLEDs(unsigned char LEDflags)
{
	LEDs = LEDflags;

	// Agp҂LEDݒXVAI/O݂̕ԂXV܂B
	DDRB |= (1<<4) | (1<<5) | (1<<7);
	DDRD |= (1<<0) | (1<<1);

}

// ISR͂̐݌vɉSB100 PCDŔCӑIgp҂ެߐݒ肷
// 肵5LEDԂ񂵂܂B̊荞݂n̂ƋPWM@\g
// ܂BPWM݂łHigho͉͂LED쓮܂BvLEDo͂
// Aɏo͂OFFɐ؂ւA]āA(gp҂őPx咣Ȃ(
// ̏ꍇAOFFԂ͂܂))LEDOFF̊Ԃɐ؂ւ܂B

//! \todo tꂽɑSĂ̋x~삩Nオ邱Ƃdrɋ
//!		  ߁A̒ǉ@\邱Ƃł܂B݁Adr߯͋x~
//!		  łȂɂ܂B

//extern unsigned char LEDflags;

#pragma vector = TIMER0_COMPA_vect
__interrupt void T0CMPA_ISR(void)
{
	static unsigned char select = 0;
	unsigned char temp = select;

	if(PINA & (1<<7))		// PA7High?
	{
		DDRB &= ~(1<<6);	// LEDɑ΂쓮OFF
		PORTB &= ~(1<<6);
		return;
	}
	else
		DDRB |= (1<<6);		// PB6o͋쓮

	temp++;
	if(6 == temp)
		temp = 1;
	select = temp;

	// ŏɑSLED߰ĂHighɐݒ
	PORTB |= (1<<4) | (1<<5) | (1<<7);
	PORTD |= (1<<0) | (1<<1);

	// ɑIlLEDޯĂɊÂ1Lowɐݒ
	if((temp == 1) && (LEDs & (1<<0)))
		PORTB &= ~(1<<4);
	else
		if((temp == 2) && (LEDs & (1<<1)))
			PORTB &= ~(1<<5);
	else
		if((temp == 3) && (LEDs & (1<<2)))
			PORTB &= ~(1<<7);
	else
		if((temp == 4) && (LEDs & (1<<3)))
			PORTD &= ~(1<<0);
	else
		if((temp == 5) && (LEDs & (1<<4)))
			PORTD &= ~(1<<1);

	return;
}

// ꂪ̐݌vŏ[dƗ\[dFETPWMs邽߁Å荞݂gK
// v܂B̊荞݂͒ʏ틖܂񂪁Â߂ɍsނ͂łB
#pragma vector = TIMER0_COMPB_vect
__interrupt void T0_COMPB_ISR(void)
{
	return;		//! \todo Ϗ[dd𐧌䂷邽߂ɏ[dFETPWMKvȏꍇɺނɒǉĂB
}

// : ̑SĂISRnÂɂZĂB

void generictimer0expired(void)
{
	SMB_RestoreBus();
	return;
}

void generictimer1expired(void)
{
	SetQtrSec;
	return;
}

void generictimer2expired(void)
{
	// gpҎgpp
	return;
}

void generictimer3expired(void)
{
	// gpҎgpp
	return;
}

void generictimer4expired(void)
{
	// gpҎgpp
	return;
}

void generictimer5expired(void)
{
	// gpҎgpp
	return;
}

void generictimer6expired(void)
{
	// gpҎgpp
	return;
}

void generictimer7expired(void)
{
	// gpҎgpp
	return;
}

// x1msԊuŗ^܂A2msԊuŌv܂B
void SetGenericTimer(unsigned char index, unsigned int delay)
{
	++delay;
	delay >>= 1;		// 1msԊu2ms\ɕϊ
	generictimer[index] = (unsigned char) delay;
}

unsigned char GetGenericTimer(unsigned char index)
{
	return generictimer[index];
}

typedef void (*ptr2funcV_V)(void);

// MSMBus޲ĂwE@\ւ̈ʒuwq̕\
ptr2funcV_V GenericExpire[8] =
{
	generictimer0expired,
	generictimer1expired,
	generictimer2expired,
	generictimer3expired,
	generictimer4expired,
	generictimer5expired,
	generictimer6expired,
	generictimer7expired
};

// ̊荞݂ͺނɑ΂v퍏Ƃċ@\܂BAʌv̈
// ܂B0ɒB鎞͕K̊ԏI֐Ă΂܂BT0p̑O
// u킪8ɏ邽߁A2.048msɎn܂B
#pragma vector = TIMER0_OVF_vect
__interrupt void T0OVF_ISR(void)
{
	unsigned int temp;
	unsigned char i;

	for(i=0; i<8; i++)
	{
		temp = generictimer[i];
		if(0 != temp)
		{
			temp--;
			generictimer[i] = temp;
			if(temp == 0)				// 0ɓ鎞ɂ}
				(GenericExpire[i])();
		}
	}

	return;
}

// v1͂̐݌vŎg܂B

void T1init(void)
{
	return;
}

#pragma vector = TIMER1_COMP_vect
__interrupt void T1CMP_ISR(void)
{
	return;
}

#pragma vector = TIMER1_OVF_vect
__interrupt void T1OVF_ISR(void)
{
	return;
}


/* *****************************************************
 *
 *
 *
 *
 * *****************************************************/

void Wdog_init(unsigned char mode, unsigned char rate)
{
	unsigned char temp = rate;
	unsigned char flags;

	if(mode == WDOG_MODE_DISABLED)
	{
		MCUSR &= ~(1<<WDRF);
		flags = SREG;
		__disable_interrupt();
		__watchdog_reset();
		WDTCSR = (1<<WDCE);
		WDTCSR = 0;
		if(flags & (1<<7))			// OɊ荞݂ĂȂA
			__enable_interrupt();	// ċ
		return;
	}

	if(temp > 9)
		temp = 9;
	if(temp & 0x08)
	{
		temp &= 0x07;
		temp |= 0x20;
	}

	if(mode & WDOG_MODE_INTERRUPT)
	{
		temp |= 1<<WDIE;
	}

//	if(mode & WDOG_MODE_RESET)		// ̓ɑ΂ēʂȺނKvƂ܂B
//	{
//		;
//	}

	temp |= (1<<WDIF) | (1<<WDE);	// Ɋ荞׸ނ悤Ƃ܂B

	flags = SREG;
	__disable_interrupt();
	__watchdog_reset();
	WDTCSR |= (1<<WDCE) | (1<<WDE);
	WDTCSR = temp;
	if(flags & (1<<7))				// OɊ荞݂ĂȂA
		__enable_interrupt();		// ċ
}

#pragma vector = WDT_vect
__interrupt void WDT_ISR(void)
{
	return;		//! \todo ̎ł͕sgp
}


/* *****************************************************************************
 *
 * NvĊJnAXɋx~ɉ݂܂Bꂪɑs̏
 * A͌vؾĂAOɒ`ꂽxł̌p܂B
 *
 * ꂪɑsĂɋNオԊuύXꍇ4bxh߁A
 * ݂̐ݒ̋ǏێĔr܂BxύX鎞͕Kv
 * IؾĂ܂B
 *
 * Ԃ: OKȂ0AvꂽsȒxl܂͋x~̏ꍇ1
 *
 * ****************************************************************************/
char setWakeup(unsigned char delay, unsigned char sleepmode)
{
	static unsigned char LastDelay = 0;
	unsigned char temp;

	if(delay > WU4sec)
		return 1;

	if(WUoff == delay)
	{
		WUTCSR = (WUTIF | WUTR);
		LastDelay = delay;
		return 0;
	}
	else
	if(LastDelay != delay)
		WUTCSR = ((delay-1) | WUTE | WUTIE | WUTR);
	else
		WUTCSR = ((delay-1) | WUTE | WUTIE);
	LastDelay = delay;

	// x~ŗLɂ܂AꂪvĂꍇłB
	if(SLEEP_NONE == sleepmode)
		return 0;
	if(SLEEP_POWEROFF < sleepmode)
		return 1;
	temp = sleepmode & ~(1<<SE);
	SMCR = sleepmode | (1<<SE);
	__sleep();

	// NオAްĂSEޯĂׂƂ܂B
	SMCR = temp;
	return 0;
}

#pragma vector = WAKE_UP_vect
__interrupt void WakeUp_ISR(void)
{
	RunningAcc -= PACK_HIBERNATEAMOUNT;
	return;
}
