// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: pwrmgmt.c
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - drQƊ݌v
*
* - 		: d͊Ǘ
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:40 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

//#include "iom406_320.h"
#include <iom406.h>			// ATmega406pIAR(EW 410)ͯ ̧
#include <inavr.h>

#define MODULE_PWRMGMT
#include "pwrmgmt.h"

#include "ee.h"
#include "analog.h"
#include "timer.h"

void SetPowerSaveMode(void);
void SetIdleMode(void);
void SetActiveMode(void);

// LȏԑJڂs邱Ƃۗ{邽߁ASĂ̓`ԕύXٰ͂
// gׂłBڍׂɂĂAVR453B
void ChangePowerMode(unsigned char newmode, unsigned char shutdown_reason)
{
	switch (PowerMode)		// ݂ǂ̓?
	{
		case POWERMODE_POWERSAVE:
			if(newmode == POWERMODE_ACTIVE)
				SetActiveMode();
			else
			if(newmode == POWERMODE_POWEROFF)
				DoShutdown(shutdown_reason);
			break;

		case POWERMODE_IDLE:
			if(newmode == POWERMODE_ACTIVE)
				SetActiveMode();
			else
			if(newmode == POWERMODE_POWERSAVE)
				SetPowerSaveMode();
			else
			if(newmode == POWERMODE_POWEROFF)
				DoShutdown(shutdown_reason);
			break;

		case POWERMODE_ACTIVE:
			if(newmode == POWERMODE_IDLE)
				SetIdleMode();
			else
			if(newmode == POWERMODE_POWERSAVE)
				SetPowerSaveMode();
			else
			if(newmode == POWERMODE_POWEROFF)
				DoShutdown(shutdown_reason);
			break;

		case POWERMODE_POWEROFF:
		default:
			if(newmode == POWERMODE_POWEROFF)
				DoShutdown(SHUTDOWN_REASON_UNKNOWNSTATE);
			else
				SetPowerSaveMode();
			break;
	}
}

void DoShutdown(unsigned char reason)
{
	__disable_interrupt();

	// EEPROMɗR(REASON)i[
	while(EECR & (1<<EEPE));
	while(SPMCSR & (1<<SPMEN));
	EEAR = EESTORAGE_SHUTDOWNREASON;
	EEDR = reason;
	EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (0<<EEPE) | (0<<EERE);	// arm
	EECR = (0<<EEPM1) | (0<<EEPM0) | (0<<EERIE) | (1<<EEMPE) | (1<<EEPE) | (0<<EERE);	// go
	while(EECR & (1<<EEPE));			// I܂ő҂

	SMCR = SLEEP_POWEROFF | (1<<SE);	// ܰ̓쏀
	__sleep();
}

void SetPowerSaveMode(void)
{
	CCmode(CC_DISABLED);
	FCSR = 0;
	SMCR = SLEEP_POWERSAVE;
	PowerMode = POWERMODE_POWERSAVE;
	setWakeup(WU4sec, SLEEP_NONE);
}

void SetIdleMode(void)
{
	CCmode(CC_REGULAR);
	FCSR = ((1<<DFE) | (1<<CFE) | (1<<PFD));
	SMCR = SLEEP_IDLE;
	PowerMode = POWERMODE_IDLE;
}

void SetActiveMode(void)
{
	CCmode(CC_ACCUMULATE);
	FCSR = ((1<<DFE) | (1<<CFE) | (1<<PFD));
	SMCR = SLEEP_IDLE;
	PowerMode = POWERMODE_ACTIVE;
		setWakeup(WUoff,0);
}
