// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: pwrmgmt.h
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - dr/ATAVRSB100
*
* - 		: pwrmgmt.cpͯ ̧
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:40 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

// SMCRp̒l
#define SLEEP_NONE				0
#define SLEEP_IDLE				0
#define SLEEP_ADCNR				2
#define SLEEP_POWERDOWN			4
#define SLEEP_POWERSAVE			6
#define SLEEP_POWEROFF			8

void DoShutdown(unsigned char reason);
#define SHUTDOWN_REASON_UNDERVOLTAGE			1
#define SHUTDOWN_REASON_CHARGE_OVERCURRENT		2
#define SHUTDOWN_REASON_DISCHARGE_OVERCURRENT	3
#define SHUTDOWN_REASON_OVERVOLTAGE				4
#define SHUTDOWN_REASON_SHORTCIRCUIT			5
#define SHUTDOWN_REASON_OVERTEMPERATURE			6
#define SHUTDOWN_REASON_UNKNOWNSTATE			7

void ChangePowerMode(unsigned char newmode, unsigned char shutdown_reason);
#define POWERMODE_POWEROFF		0
#define POWERMODE_POWERSAVE		1
#define POWERMODE_IDLE			2
#define POWERMODE_ACTIVE		3

#ifdef MODULE_PWRMGMT
  unsigned char PowerMode = 0;
#else
  extern unsigned char PowerMode;
#endif
