// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: smbus.h
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - dr/ATAVRSB100
*
* - 		: smbus.cpͯ ̧
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:42 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

// ^錾
void InitSMBus(void);
void SMB_Master(void);
void MasterInsertMsg(unsigned char addr, unsigned char cmd, unsigned int data);
void SMB_CmdInterpreter(void);
void SMB_RestoreBus(void);		// ޽Q񕜂邽߂̈ʌvӂɂĎg܂B
void InitSMBvariables(void);
void Check50uS(void);


#define SMBvariables SV.SMBvar
#define SMBvar_int   SV.SMBint

#ifdef MODULE_SMBUS
  union { volatile unsigned char SMBvar[29][2]; volatile unsigned int SMBint[29]; } SV;

  // : SĂ̕Addr+Cmd+PECp̕揊TW_TxBufɓKȂ΂Ȃ܂B
  //	 ܂AȇO͂̎̕c̒"萔"ŁA̒萔8ił!!B
  __flash char str_MfrName[]    = "\014Atmel Norway";	// __flash char
  __flash char str_DeviceName[] = "\005SB100";
  __flash char str_DeviceChem[] = "\004LION";
  __flash char str_MfrData[]    = "\013MfrDataArea";

#else

  extern union { volatile unsigned char SMBvar[29][2]; volatile unsigned int SMBint[29]; } SV;

#endif

#define HOST_ADDR			0x10	// SMNusdlǕCΉ
#define CHARGER_ADDR		0x12
#define BATTERY_ADDR		0x16

// ȉ̖߂[dւ̎呕u݂Ə]uǂݍ݂̗ȂƂɒӂĂB
#define SMB_M_CMD_CHARGINGCURRENT	0x14
#define SMB_M_CMD_CHARGINGVOLTAGE	0x15

// ̖߂͏[dνĂ̗ڽɑ΂呕uݐpłB
#define SMB_M_CMD_ALARMWARNING		0x16

// SMBusϐ+ߖψʈꗗ
#define SMBV_MfrAccess		 0
#define SMBV_RemCapAlm		 1
#define SMBV_RemTimeAlm		 2
#define SMBV_BattMode		 3
#define SMBV_AtRate			 4
#define SMBV_AtRateTTF		 5
#define SMBV_AtRateTTE		 6
#define SMBV_AtRateOK		 7

#define SMBV_Temperature	 8
#define SMBV_Voltage		 9
#define SMBV_Current		10
#define SMBV_AvgCurrent		11
#define SMBV_MaxError		12
#define SMBV_RelSOC			13
#define SMBV_AbsSOC			14
#define SMBV_RemCap			15

#define SMBV_FullChgCap		16
#define SMBV_RunTTE			17
#define SMBV_AvgTTE			18
#define SMBV_AvgTTF			19
#define SMBV_ChgCurrent		20
#define SMBV_ChgVoltage		21
#define SMBV_BattStatus		22
#define SMBV_CycleCount		23

#define SMBV_DesignCap		24
#define SMBV_DesignVolt		25
#define SMBV_SpecInfo		26
#define SMBV_MfrDate		27
#define SMBV_SerialNo		28

#define SMBV_MfrName		32
#define SMBV_DeviceName		33
#define SMBV_DeviceChem		34
#define SMBV_MfrData		35
#define SMBV_Opt5			0x2F
#define SMBV_Opt4			0x3C
#define SMBV_Opt3			0x3D
#define SMBV_Opt2			0x3E
#define SMBV_Opt1			0x3F

// 29 SMBusϐvf̊eX̕ψ
#define lobyte				0
#define hibyte				1

// SMBV_BatteryModeޯĒ`

// ޲
#define CHARGE_CONTROLLER_ENABLED	0x01
#define PRIMARY_BATTERY				0x02
#define ALARM_MODE					0x20
#define CHARGER_MODE				0x40
#define CAPACITY_MODE				0x80

// ޲
#define INTERNAL_CHARGE_CONTROLLER	0x01
#define PRIMARY_BATTERY_SUPPORT		0x02
#define CONDITION_FLAG				0x80

// SMBV_BatteryStatusޯĒ`

// ޲
/* * * * * * xޯ * * * * */
#define OVER_CHARGED_ALARM			0x80
#define TERMINATE_CHARGE_ALARM		0x40
#define OVER_TEMP_ALARM				0x10
#define TERMINATE_DISCHARGE_ALARM	0x08
#define REMAINING_CAPACITY_ALARM	0x02
#define REMAINING_TIME_ALARM		0x01

// ޲
/* * * * * * ޯ * * * * */
#define INITIALIZED					0x80
#define DISCHARGING					0x40
#define FULLY_CHARGED				0x20
#define FULLY_DISCHARGED			0x10

/* * * * * * ُ필 * * * * */
#define SMBerr_OK					0x00	// R/W dr͂ǂُ̈oɋ@\܂B
#define SMBerr_Busy					0x01	// R/W dr͂̎_ŋ@\邱Ƃł܂B
#define SMBerr_ReservedCommand		0x02	// R/W dr͂̔ł̎dlŗ\񂳂ꂽ@\ւ̓ǂݏ݂̎o܂B
											//     dr͖x̔CӑI𐻑Ǝҋ@\̱݂̎o܂B
#define SMBerr_UnsuptdCommand		0x03	// R/W dr͂̔ł̎dlŒ`邱̋@\x܂B
#define SMBerr_AccessDenied			0x04	//  W  dr͓͂ǂݍݐp@\ւ݂̏o܂B
#define SMBerr_OverUnderflow		0x05	// R/W drް̉ߑ܂͉ߏo܂B
#define SMBerr_BadSize				0x06 	//  W  dr͕sȑ傫ް@\ւ݂݂̏̎o܂B
#define SMBerr_UnknownError			0x07 	// R/W dr͎ʕs\ُ̈o܂B
